/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function a(s,o,u){function l(n,e){if(!o[n]){if(!s[n]){var t="function"==typeof require&&require;if(!e&&t)return t(n,!0);if(c)return c(n,!0);var r=new Error("Cannot find module '"+n+"'");throw r.code="MODULE_NOT_FOUND",r}var i=o[n]={exports:{}};s[n][0].call(i.exports,function(e){var t=s[n][1][e];return l(t||e)},i,i.exports,a,s,o,u)}return o[n].exports}for(var c="function"==typeof require&&require,e=0;e<u.length;e++)l(u[e]);return l}({1:[function(e,t,n){"use strict";var N={promise:null,load:function(e){"undefined"!=typeof Twitch?N.promise=new Promise(function(e){e()}).then(function(){N._createPlayer(e)}):(N.promise=N.promise||mejs.Utils.loadScript("https://player.twitch.tv/js/embed/v1.js"),N.promise.then(function(){N._createPlayer(e)}))},_createPlayer:function(e){var t=new Twitch.Player(e.id,e);window["__ready__"+e.id](t)},getTwitchId:function(e){var t="";return 0<e.indexOf("?")?""===(t=N.getTwitchIdFromParam(e))&&(t=N.getTwitchIdFromUrl(e)):t=N.getTwitchIdFromUrl(e),t},getTwitchIdFromParam:function(e){if(null==e||!e.trim().length)return null;for(var t=e.split("?")[1].split("&"),n="",r=0,i=t.length;r<i;r++){var a=t[r].split("=");if(~a[0].indexOf("channel")){n=a[1];break}if(~a[0].indexOf("video")){n="v"+a[1];break}}return n},getTwitchIdFromUrl:function(e){if(null==e||!e.trim().length)return null;var t=(e=e.split("?")[0]).substring(e.lastIndexOf("/")+1);return/^\d+$/i.test(t)?"v"+t:t},getTwitchType:function(e){return/^v\d+/i.test(e)?"video":"channel"}},r={name:"twitch_iframe",options:{prefix:"twitch_iframe"},canPlayType:function(e){return~["video/twitch","video/x-twitch"].indexOf(e.toLowerCase())},create:function(h,e,t){var f={},p=[],a=N.getTwitchId(t[0].src),m=null,v=!1;f.options=e,f.id=h.id+"_"+e.prefix,f.mediaElement=h;for(var n=mejs.html5media.properties,r=function(i){var e=""+i.substring(0,1).toUpperCase()+i.substring(1);f["get"+e]=function(){if(null!==m){switch(i){case"currentTime":return m.getCurrentTime();case"duration":return m.getDuration();case"volume":return m.getVolume();case"paused":return m.isPaused();case"ended":return m.getEnded();case"muted":return m.getMuted();case"buffered":return{start:function(){return 0},end:function(){return 0},length:1};case"src":return"channel"===N.getTwitchType(a)?m.getChannel():m.getVideo();case"readyState":return 4}return null}return null},f["set"+e]=function(e){if(null!==m)switch(i){case"src":var t="string"==typeof e?e:e[0].src,n=N.getTwitchId(t);"channel"===N.getTwitchType(a)?m.setChannel(n):m.setVideo(n);break;case"currentTime":m.seek(e),setTimeout(function(){var e=mejs.Utils.createEvent("timeupdate",f);h.dispatchEvent(e)},50);break;case"muted":m.setMuted(e),setTimeout(function(){var e=mejs.Utils.createEvent("volumechange",f);h.dispatchEvent(e)},50);break;case"volume":e,m.setVolume(e),setTimeout(function(){var e=mejs.Utils.createEvent("volumechange",f);h.dispatchEvent(e)},50);break;case"readyState":var r=mejs.Utils.createEvent("canplay",f);h.dispatchEvent(r)}else p.push({type:"set",propName:i,value:e})}},i=0,s=n.length;i<s;i++)r(n[i]);for(var o=mejs.html5media.methods,u=function(e){f[e]=function(){if(null!==m)switch(e){case"play":return!1,m.play();case"pause":return!0,m.pause();case"load":return null}else p.push({type:"call",methodName:e})}},l=0,c=o.length;l<c;l++)u(o[l]);function g(e){for(var t=0,n=e.length;t<n;t++){var r=mejs.Utils.createEvent(e[t],f,!0);h.dispatchEvent(r)}}window["__ready__"+f.id]=function(e){if(h.twitchPlayer=m=e,p.length)for(var t=0,n=p.length;t<n;t++){var r=p[t];if("set"===r.type){var i=r.propName,a=""+i.substring(0,1).toUpperCase()+i.substring(1);f["set"+a](r.value)}else"call"===r.type&&f[r.methodName]()}var s=document.getElementById(f.id).firstChild;s.style.width="100%",s.style.height="100%";for(var o=["mouseover","mouseout"],u=function(e){var t=mejs.Utils.createEvent(e.type,f);h.dispatchEvent(t)},l=0,c=o.length;l<c;l++)s.addEventListener(o[l],u,!1);var d=void 0;m.addEventListener(Twitch.Player.READY,function(){!1,g(["rendererready","loadedmetadata","loadeddata","canplay"])}),m.addEventListener(Twitch.Player.PLAY,function(){v||(v=!0),!1,g(["play","playing","progress"]),d=setInterval(function(){m.getCurrentTime(),g(["timeupdate"])},250)}),m.addEventListener(Twitch.Player.PAUSE,function(){!0,!1,m.getEnded()||g(["pause"])}),m.addEventListener(Twitch.Player.ENDED,function(){!0,g(["ended"]),clearInterval(d),v=!1,d=null})};var d=h.originalNode.height,y=h.originalNode.width,w=document.createElement("div"),T=N.getTwitchType(a),E={id:f.id,width:y,height:d,playsinline:!1,autoplay:h.originalNode.autoplay,muted:h.originalNode.muted};return E[T]=a,w.id=f.id,w.style.width="100%",w.style.height="100%",h.originalNode.parentNode.insertBefore(w,h.originalNode),h.originalNode.style.display="none",h.originalNode.autoplay=!1,f.setSize=function(e,t){null===N||isNaN(e)||isNaN(t)||(w.setAttribute("width",e),w.setAttribute("height",t))},f.hide=function(){f.pause(),w.style.display="none"},f.show=function(){w.style.display=""},f.destroy=function(){},N.load(E),f}};mejs.Utils.typeChecks.push(function(e){return/\/\/(www|player).twitch.tv/i.test(e)?"video/x-twitch":null}),mejs.Renderers.add(r)},{}]},{},[1]);